VERSION 1.0 CLASS
BEGIN
  MultiUse = -1  'True
  Persistable = 0  'NotPersistable
  DataBindingBehavior = 0  'vbNone
  DataSourceBehavior  = 0  'vbNone
  MTSTransactionMode  = 0  'NotAnMTSObject
END
Attribute VB_Name = "StringPerm"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = True
Attribute VB_PredeclaredId = False
Attribute VB_Exposed = False
Option Explicit
Private mElement() As String
Private mOrder As Long

'create a StringPerm object which is the 0th (identity) element
'Optional k: create a StringPerm object which is the kth element
Public Sub NewC(atoms() As String, Optional ByVal k As Long = -1)
  mElement = atoms
  mOrder = UBound(mElement) - LBound(atoms) + 1
  
  If k >= 0 Then
    ReDim factoradic(mOrder - 1) As Long
    Dim i As Long, j As Long
    
    ' Step #1 - Find factoradic of k
    For j = 1 To mOrder
        factoradic(mOrder - j) = k Mod j
        k = k / j
    Next

    ' Step #2 - Convert factoradic() to numeric permuatation in perm()
    ReDim temp(mOrder - 1) As Long
    ReDim perm(mOrder - 1) As Long

    For i = 0 To mOrder - 1
        temp(i) = factoradic(i) + 1
    Next

    perm(mOrder - 1) = 1 ' right-most value is set to 1.

    For i = mOrder - 2 To 0 Step -1
        perm(i) = temp(i)
        For j = i + 1 To mOrder - 1
            If (perm(j) >= perm(i)) Then perm(j) = perm(j) + 1
        Next
    Next

    For i = 0 To mOrder - 1 ' put in 0-based form
        perm(i) = perm(i) - 1
    Next
    ' Step #3 - map numeric permutation to string permutation
    For i = 0 To mOrder - 1
        mElement(i) = atoms(perm(i))
    Next
  End If
End Sub

Public Property Get Element(Index As Long) As String
  Element = mElement(Index)
End Property

Public Property Let Element(Index As Long, RHS As String)
  mElement(Index) = RHS
End Property

Public Property Get Order() As Long
  Order = mOrder
End Property

Public Property Let Order(RHS As Long)
  mOrder = RHS
End Property

Public Function ToString() As String
    Dim result As String: result = "{ "
    Dim i As Long
    
    For i = 0 To mOrder - 1
        result = result & mElement(i) & " "
    Next
    
    result = result & "}"
    ToString = result
End Function

Public Function Successor() As StringPerm ' assumes no duplicate atoms
    Dim result As StringPerm: Set result = New_StringPerm(mElement)
    Dim left As Long, right As Long
    Dim temp As String
    Dim i As Long
    Dim j As Long

    left = result.Order - 2 ' Step #1 - Find left value
    Do While (StrComp(result.Element(left), result.Element(left + 1)) > 0) And (left > 0)
        left = left - 1
    Loop
    
    If (left = 0) And (StrComp(mElement(left), mElement(left + 1)) > 0) Then
        Exit Function
    End If
    
    right = result.Order - 1 ' Step #2 - find right; first value > left
    Do While (StrComp(result.Element(left), result.Element(right)) > 0)
        right = right - 1
    Loop

    temp = result.Element(left) ' Step #3 - swap (left) and (right)
    result.Element(left) = result.Element(right)
    result.Element(right) = temp

    i = left + 1 ' Step #4 - reverse order the tail
    j = result.Order - 1

    Do While (i < j)
        temp = result.Element(i)
        result.Element(i) = result.Element(j)
        i = i + 1
        result.Element(j) = temp
        j = j - 1
    Loop

    Set Successor = result
End Function

